# coding: utf-8

"""
    SatNOGS DB

    SatNOGS DB is a crowdsourced database of details about orbital                     satellites and data collected from them.

    The version of the OpenAPI document: 1.1
    Contact: dev@satnogs.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Telemetry(BaseModel):
    """
    SatNOGS DB Telemetry API Serializer
    """ # noqa: E501
    sat_id: StrictStr = Field(description="Returns Satellite Identifier")
    norad_cat_id: StrictInt = Field(description="Returns Satellite NORAD ID")
    transmitter: StrictStr = Field(description="Returns Transmitter UUID")
    decoded: StrictStr = Field(description="Returns the payload_decoded field")
    frame: StrictStr = Field(description="Returns the payload frame")
    version: Optional[Annotated[str, Field(strict=True, max_length=45)]] = None
    observation_id: Optional[StrictInt] = None
    station_id: Optional[StrictInt] = None
    associated_satellites: Dict[str, Any] = Field(description="Returns Satellite IDs that are associated with the Satellite")
    __properties: ClassVar[List[str]] = ["sat_id", "norad_cat_id", "transmitter", "decoded", "frame", "version", "observation_id", "station_id", "associated_satellites"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Telemetry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "sat_id",
            "norad_cat_id",
            "transmitter",
            "decoded",
            "frame",
            "associated_satellites",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if observation_id (nullable) is None
        # and model_fields_set contains the field
        if self.observation_id is None and "observation_id" in self.model_fields_set:
            _dict['observation_id'] = None

        # set to None if station_id (nullable) is None
        # and model_fields_set contains the field
        if self.station_id is None and "station_id" in self.model_fields_set:
            _dict['station_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Telemetry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sat_id": obj.get("sat_id"),
            "norad_cat_id": obj.get("norad_cat_id"),
            "transmitter": obj.get("transmitter"),
            "decoded": obj.get("decoded"),
            "frame": obj.get("frame"),
            "version": obj.get("version"),
            "observation_id": obj.get("observation_id"),
            "station_id": obj.get("station_id"),
            "associated_satellites": obj.get("associated_satellites")
        })
        return _obj


